> ## Documentation Index
> Fetch the complete documentation index at: https://docs.ctrl-hub.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update a work order

> Update an existing work order



## OpenAPI

````yaml /api-reference/openapi.yaml put /v3/work-orders/{work_order_id}
openapi: 3.1.0
info:
  contact:
    email: support@ctrl-hub.com
    name: Ctrl Hub
    url: https://www.ctrl-hub.com
  description: >
    Ctrl Hub is the all-in-one platform for high-risk industries like utilities,
    construction, infrastructure, and renewables. We help teams manage
    everything from risk assessments and HAVS exposure to vehicle and equipment
    checks, with a guaranteed minimum of 200% ROI.
  license:
    name: MIT License
    url: https://opensource.org/licenses/MIT
  summary: An API for managing your compliance and risk posture
  termsOfService: https://www.ctrl-hub.com/terms-conditions
  title: Ctrl Hub
  version: 1.0.0
servers:
  - description: Production
    url: https://api.ctrl-hub.com
  - description: Staging
    url: https://api.ctrl-hub.dev
  - description: Development
    url: https://api.ctrl-hub.run
security: []
tags:
  - description: |
      Audit events are the events that are logged by the system.
    name: Audit Events
  - description: |
      View the platform's health and availability.
    name: Status
  - description: >
      User-owned dashboards composed of cards on a fixed-slot bento layout.
      Cards come from a per-domain registry; the API stores their config as
      opaque JSON.
    name: Dashboards
  - description: |
      Manage appointments for work to be carried out with your customers
    name: Customer Appointments
  - description: |
      Manage interactions you have with your customers
    name: Customer Interactions
  - description: |
      Manage accounts for your customers
    name: Customer Accounts and Contacts
  - description: |
      Qualifications are the skills and knowledge that an organisation requires.
    name: Qualifications
  - description: |
      Workflows allow you to automate your processes.
    name: Workflows
  - description: |
      Manage documents
    name: Documents
  - description: |
      Manage documents
    name: Folders
  - description: |
      Manage documents
    name: Document Reviews
  - description: |
      Manage feature configurations for an organisation.
    name: Feature Configurations
  - description: |
      Equipment are the physical assets that an organisation manages.
    name: Equipment
  - description: |
      Manage your forms and their schemas
    name: Forms, Schemas and Categories
  - description: |
      Create and view form submissions
    name: Submissions
  - description: |
      View the roles available in the system.
    name: IAM Roles
  - description: >
      IAM role groups can be assigned to principals to manage authorisation
      centrally.
    name: IAM Role Groups
  - description: |
      Manage service accounts which can access the API programmatically.
    name: Service Accounts
  - description: |
      Manage bridges between organisations.
    name: Bridges
  - description: |
      Manage settings for an organisation.
    name: Settings
  - description: |
      Manage teams within an organisation.
    name: Teams
  - description: |
      Manage job roles within an organisation.
    name: Job Roles
  - description: |
      Manage users and accounts.
    name: Users
  - description: |
      Invite and manage invitations to organisations.
    name: Invitations
  - description: >
      IAM grants are the asignment of roles or permissions to principals to
      manage resource access.
    name: IAM Grants
  - description: |
      View the permissions available in the system.
    name: IAM Permissions
  - description: |
      SSO providers are the identity providers for an organisation.
    name: SSO Providers
  - description: |
      Whoami returns information about the currently authenticated principal.
    name: Whoami
  - description: |
      Manage your images
    name: Images
  - description: >
      Organisations are the center point for most resources in the platform.
      Most other endpoints are subresources of an organisation.
    name: Organisations
  - description: |
      Permits managements, integrated with street manager.
    name: Permits
  - description: |
      Projects manage your work and governance.
    name: Projects
  - description: >
      Import templates allow users to save and reuse their CSV importer
      configuration as named templates.
    name: Import Templates
  - description: |
      Properties are the physical locations.
    name: Properties
  - description: |
      Search across schemes, work orders, and operations.
    name: Search
  - description: |
      Provides the API specification in JSON and YAML formats
    name: Specifications
  - description: |
      Streets are the physical roads.
    name: Streets
  - description: |
      Integration with street manager
    name: Street Manager
  - description: |
      Vehicles are the physical vehicles that an organisation manages.
    name: Vehicles
  - description: >
      Scheme contracts (also known as regions) group schemes allocated from the
      network to a contractor.
    name: Scheme Contracts
  - description: >
      Scheme shares allow you to share your schemes with other organisations
      across bridges.
    name: Scheme Shares
  - description: |
      Schemes are large programmes of work
    name: Schemes
  - description: |
      Work orders the component parts of a scheme.
    name: Work Orders
  - description: |
      Operations are the work to be carried out within work orders.
    name: Operations
externalDocs:
  description: More documentation and resources
  url: https://docs.ctrl-hub.com
paths:
  /v3/work-orders/{work_order_id}:
    put:
      tags:
        - Work Orders
      summary: Update an existing work order
      description: Update an existing work order
      operationId: UpdateWorkOrder
      parameters:
        - $ref: '#/components/parameters/work_order_id'
      requestBody:
        $ref: '#/components/requestBodies/UpdateWorkOrder'
      responses:
        '200':
          $ref: '#/components/responses/UpdateWorkOrder'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/Unauthorised'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - Session: []
        - OAuth2: []
        - Cookie: []
components:
  parameters:
    work_order_id:
      name: work_order_id
      in: path
      required: true
      description: The unique identifier for the work order.
      schema:
        type: string
        format: uuid
      example: fb082ee5-b678-4451-b02b-8269aaf262a3
  requestBodies:
    UpdateWorkOrder:
      required: true
      description: The work order to update.
      content:
        application/vnd.api+json:
          schema:
            type: object
            required:
              - data
            properties:
              data:
                type: object
                required:
                  - id
                  - type
                  - attributes
                  - relationships
                properties:
                  id:
                    type: string
                    format: uuid
                    description: The unique identifier of the work order.
                  type:
                    type: string
                    const: work-orders
                  attributes:
                    type: object
                    required:
                      - name
                    properties:
                      name:
                        type: string
                        minLength: 1
                        description: The name of the work order
                        examples:
                          - Updated Infrastructure Work Order
                      code:
                        type: string
                        description: The code of the work order
                        examples:
                          - WO002
                      description:
                        type: string
                        description: The description of the work order
                        examples:
                          - Updated installation work description
                      dates:
                        type: object
                        description: The dates associated with the work order
                        properties:
                          anticipated:
                            type: object
                            description: The anticipated start and end dates
                            properties:
                              start:
                                type: string
                                format: date-time
                                description: The anticipated start date
                                examples:
                                  - '2024-01-20T09:00:00Z'
                              end:
                                type: string
                                format: date-time
                                description: The anticipated end date
                                examples:
                                  - '2024-01-25T17:00:00Z'
                      labels:
                        type: array
                        description: The labels associated with the work order
                        items:
                          $ref: '#/components/schemas/Label'
                  relationships:
                    type: object
                    required:
                      - scheme
                    properties:
                      template:
                        type: object
                        properties:
                          data:
                            $ref: '#/components/schemas/WorkOrderTemplateRelationship'
                      scheme:
                        type: object
                        properties:
                          data:
                            $ref: '#/components/schemas/SchemeRelationship'
  responses:
    UpdateWorkOrder:
      description: The updated work order
      headers:
        Content-Type:
          $ref: '#/components/headers/content-type'
        Content-Length:
          $ref: '#/components/headers/content-length'
        X-Request-ID:
          $ref: '#/components/headers/x-request-id'
      content:
        application/vnd.api+json:
          schema:
            allOf:
              - type: object
                required:
                  - data
                properties:
                  data:
                    $ref: '#/components/schemas/WorkOrder'
              - $ref: '#/components/schemas/JSONAPI'
    BadRequest:
      description: >
        There was an error with the request - this could be due to an invalid
        body, query parameters,

        or headers that were sent to the API.
      headers:
        Content-Type:
          $ref: '#/components/headers/content-type'
        Content-Length:
          $ref: '#/components/headers/content-length'
        X-Request-ID:
          $ref: '#/components/headers/x-request-id'
      content:
        application/vnd.api+json:
          schema:
            type: object
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/Error'
          example:
            id: 98ca4a78-b66f-4234-9719-aaf832ee6669
            status: '400'
            title: A validation error was encountered
            source:
              parameter: include
            meta:
              resource: wrong_value
    Unauthorised:
      description: Authentication failed
      headers:
        Content-Type:
          $ref: '#/components/headers/content-type'
        Content-Length:
          $ref: '#/components/headers/content-length'
        X-Request-ID:
          $ref: '#/components/headers/x-request-id'
      content:
        application/vnd.api+json:
          schema:
            type: object
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/Error'
          example:
            id: 05fc9c8d-73b9-4697-9337-57f7a567a48f
            status: '401'
            title: You are not authorised to access this resource
            detail: In order to access this resource, you need the 'admin' role.
            code: AUTH.001
    InternalServerError:
      description: There was a problem handling the request on the server side
      headers:
        Content-Type:
          $ref: '#/components/headers/content-type'
        Content-Length:
          $ref: '#/components/headers/content-length'
        X-Request-ID:
          $ref: '#/components/headers/x-request-id'
      content:
        application/vnd.api+json:
          schema:
            type: object
            properties:
              errors:
                type: array
                items:
                  $ref: '#/components/schemas/Error'
          example:
            id: fe9d9a69-f0a7-4fdc-bb2c-176027f316c5
            status: '500'
            title: Internal Server Error
            detail: An unexpected error occurred on the server.
  schemas:
    Label:
      type: object
      description: A label object
      required:
        - key
        - value
      properties:
        key:
          type: string
          minLength: 1
          examples:
            - Your label key
        value:
          type: string
          examples:
            - Your label value
    WorkOrderTemplateRelationship:
      type: object
      description: Represents a relationship to a work order template
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the work order template
        type:
          type: string
          const: work-order-templates
    SchemeRelationship:
      type: object
      description: Represents a relationship to a scheme
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the scheme
        type:
          type: string
          const: schemes
    WorkOrder:
      type: object
      description: A work order
      required:
        - id
        - type
        - attributes
        - meta
        - relationships
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the work order.
          examples:
            - fb082ee5-b678-4451-b02b-8269aaf262a3
        type:
          type: string
          const: work-orders
        attributes:
          $ref: '#/components/schemas/WorkOrderAttributes'
        meta:
          $ref: '#/components/schemas/WorkOrderMeta'
        relationships:
          $ref: '#/components/schemas/WorkOrderRelationships'
    JSONAPI:
      type: object
      description: JSON API response object
      required:
        - jsonapi
      properties:
        jsonapi:
          type: object
          required:
            - version
          properties:
            version:
              type: string
              description: The version of the JSON API specification
              examples:
                - '1.0'
    Error:
      type: object
      description: An error response
      properties:
        id:
          description: >-
            A unique identifier for this particular occurrence of the problem.
            If you encounter this, please provide us with the error ID and we
            can investigate it on our side.
          type: string
          format: uuid
          examples:
            - 05fc9c8d-73b9-4697-9337-57f7a567a48f
        status:
          description: >-
            The status code for the error. This might not match the HTTP status
            code if there are more that one errors to return with different
            status codes.
          type: string
          examples:
            - '401'
            - '500'
        title:
          description: A human readable title for the error.
          type: string
          examples:
            - You are not authorised to access this resource
        detail:
          description: >-
            Where there is more detail that we can provide outside of the title,
            we will provide it here.
          type: string
          examples:
            - In order to access this resource, you need the 'admin' role.
        code:
          description: >-
            A unique code for the error that may help us to diagnose the issue.
            Not all errors have codes, so this is usually empty.
          type: string
          examples:
            - AUTH.001
        source:
          description: A JSON object containing additional information about the error.
          type: object
          properties:
            pointer:
              description: >-
                A JSON Pointer to the value in the request that caused the
                error.
              type: string
              examples:
                - /data/attributes/email
            parameter:
              description: >-
                A string indicating which query parameter in the request caused
                the error.
              type: string
              examples:
                - include
      required:
        - id
        - status
        - title
    WorkOrderAttributes:
      type: object
      description: Attributes for a work order
      required:
        - name
      properties:
        name:
          type: string
          description: The name of the work order
          examples:
            - Infrastructure Maintenance Work Order
        code:
          type: string
          description: The code of the work order
          examples:
            - WO-2025-001
        description:
          type: string
          description: The description of the work order
          examples:
            - Routine maintenance and inspection of electrical infrastructure
        dates:
          type: object
          description: The dates associated with the work order
          properties:
            anticipated:
              type: object
              description: The anticipated start and end dates
              properties:
                start:
                  type: string
                  format: date-time
                  description: The anticipated start date
                  examples:
                    - '2025-08-01T09:00:00Z'
                end:
                  type: string
                  format: date-time
                  description: The anticipated end date
                  examples:
                    - '2025-08-15T17:00:00Z'
        labels:
          type: array
          description: The labels associated with the work order
          items:
            $ref: '#/components/schemas/Label'
    WorkOrderMeta:
      type: object
      description: Metadata for a work order
      required:
        - created_at
        - updated_at
        - modified_at
        - counts
        - dates
        - completeness
      properties:
        created_at:
          type: string
          format: date-time
          description: The date and time when the work order was created
          examples:
            - '2025-05-06T18:37:12Z'
        updated_at:
          type: string
          format: date-time
          description: The date and time when the work order was last updated
          examples:
            - '2025-05-07T21:12:46Z'
        modified_at:
          type: string
          format: date-time
          description: The date and time when the work order was last modified
          examples:
            - '2025-05-07T21:12:46Z'
        dates:
          type: object
          description: The scheduled dates for the work order
          properties:
            scheduled:
              type: object
              description: The scheduled start and end dates
              properties:
                start:
                  type: string
                  format: date-time
                  description: The scheduled start date
                  examples:
                    - '2025-08-01T09:00:00Z'
                end:
                  type: string
                  format: date-time
                  description: The scheduled end date
                  examples:
                    - '2025-08-15T17:00:00Z'
        counts:
          type: object
          description: The counts of related entities
          required:
            - operations
            - properties
            - streets
          properties:
            operations:
              type: integer
              description: The number of operations in this work order
              format: int64
              minimum: 0
              default: 0
              examples:
                - 1
            streets:
              type: integer
              description: >-
                The number of streets in this work order (from all of the
                operations in this work order)
              format: int64
              minimum: 0
              default: 0
              examples:
                - 1
            properties:
              type: integer
              description: >-
                The number of properties in this work order (from all of the
                operations in this work order)
              format: int64
              minimum: 0
              default: 0
              examples:
                - 1
        completeness:
          type: object
          description: The completeness statistics for the work order
          required:
            - percentage
            - counts
            - statuses
            - done_reasons
          properties:
            percentage:
              type: object
              description: The percentage breakdown of completion status
              required:
                - completed
                - aborted
                - unknown
                - cancelled
              properties:
                completed:
                  type: number
                  minimum: 0
                  maximum: 100
                  default: 0
                  description: The percentage of completed operations
                  examples:
                    - 25
                aborted:
                  type: number
                  minimum: 0
                  maximum: 100
                  default: 0
                  description: The percentage of aborted operations
                  examples:
                    - 0
                unknown:
                  type: number
                  minimum: 0
                  maximum: 100
                  default: 0
                  description: The percentage of operations with unknown status
                  examples:
                    - 75
                cancelled:
                  type: number
                  minimum: 0
                  maximum: 100
                  default: 0
                  description: The percentage of cancelled operations
                  examples:
                    - 0
            counts:
              type: object
              description: The count breakdown of completion status
              required:
                - completed
                - aborted
                - unknown
                - cancelled
              properties:
                completed:
                  type: integer
                  minimum: 0
                  default: 0
                  description: The number of completed operations
                  examples:
                    - 1
                aborted:
                  type: integer
                  minimum: 0
                  default: 0
                  description: The number of aborted operations
                  examples:
                    - 0
                unknown:
                  type: integer
                  minimum: 0
                  default: 0
                  description: The number of operations with unknown status
                  examples:
                    - 3
                cancelled:
                  type: integer
                  minimum: 0
                  default: 0
                  description: The number of cancelled operations
                  examples:
                    - 0
            statuses:
              type: object
              required:
                - counts
                - percentages
              properties:
                counts:
                  type: object
                  required:
                    - done
                    - in_progress
                    - todo
                  properties:
                    done:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 3
                    in_progress:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 1
                    todo:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 1
                percentages:
                  type: object
                  required:
                    - done
                    - in_progress
                    - todo
                  properties:
                    done:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 60
                    in_progress:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 20
                    todo:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 20
            done_reasons:
              type: object
              required:
                - counts
                - percentages
              properties:
                counts:
                  type: object
                  required:
                    - aborted
                    - cancelled
                    - completed
                  properties:
                    aborted:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 1
                    cancelled:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 2
                    completed:
                      type: integer
                      minimum: 0
                      default: 0
                      examples:
                        - 2
                percentages:
                  type: object
                  required:
                    - aborted
                    - cancelled
                    - completed
                  properties:
                    aborted:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 20
                    cancelled:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 40
                    completed:
                      type: number
                      minimum: 0
                      maximum: 100
                      default: 0
                      examples:
                        - 40
    WorkOrderRelationships:
      type: object
      description: Relationships for a work order
      required:
        - organisation
        - scheme
        - operations
      properties:
        organisation:
          type: object
          required:
            - data
          properties:
            data:
              $ref: '#/components/schemas/OrganisationRelationship'
        assignees:
          type: object
          required:
            - data
          properties:
            data:
              type: array
              items:
                $ref: '#/components/schemas/UserRelationship'
        teams:
          type: object
          required:
            - data
          properties:
            data:
              type: array
              items:
                $ref: '#/components/schemas/TeamRelationship'
        scheme:
          type: object
          required:
            - data
          properties:
            data:
              $ref: '#/components/schemas/SchemeRelationship'
        operations:
          type: object
          required:
            - data
          properties:
            data:
              type: array
              items:
                $ref: '#/components/schemas/OperationRelationship'
        template:
          type: object
          required:
            - data
          properties:
            data:
              $ref: '#/components/schemas/WorkOrderTemplateRelationship'
        site_managers:
          type: object
          required:
            - data
          properties:
            data:
              type: array
              items:
                $ref: '#/components/schemas/UserRelationship'
        folder:
          type: object
          required:
            - data
          properties:
            data:
              $ref: '#/components/schemas/FolderRelationship'
    OrganisationRelationship:
      type: object
      description: Represents a relationship to an organisation
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the organisation
        type:
          type: string
          const: organisations
    UserRelationship:
      type: object
      description: Represents a relationship to a user
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the user
        type:
          type: string
          const: users
    TeamRelationship:
      type: object
      description: Represents a relationship to a team
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the team
        type:
          type: string
          const: teams
    OperationRelationship:
      type: object
      description: Represents a relationship to an operation
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the operation
        type:
          type: string
          const: operations
    FolderRelationship:
      type: object
      description: Represents a relationship to a folder
      required:
        - id
        - type
      properties:
        id:
          type: string
          format: uuid
          description: The unique identifier of the folder
        type:
          type: string
          const: folders
  headers:
    content-type:
      description: The content type of the response
      schema:
        type: string
      example: application/vnd.api+json
    content-length:
      description: The length of the response body in bytes
      schema:
        type: integer
        format: int32
      example: 1234
    x-request-id:
      description: >-
        An ID that can be provided when reporting bugs to help identify the
        issue
      schema:
        type: string
      example: 8470f56af4cf25e22be08e72c70dbbdc
  securitySchemes:
    Session:
      description: |
        Session token for authentication.
      in: header
      name: X-Session-Token
      type: apiKey
    OAuth2:
      description: |
        OAuth2 token for authentication.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: https://auth.ctrl-hub.com/oauth2/token
      type: oauth2
    Cookie:
      description: |
        Cookie token for authentication.
      in: cookie
      name: ctrl_hub_session
      type: apiKey

````